In Bash scripts set -e
The -h option instructs the shell to exit if the command returns a non-zero exit status set -e
. In simple terms, the shell exits if the command fails.
In Debian package management scripts, set -e
this is also known as set -o errexit
. According to Debian policy, this option is required in some scripts; the goal seems to be to avoid any unhandled error conditions.
In practice, this means that you must understand the situations in which the commands you run might return errors and address each problem explicitly.
Use outside of a Bash functionset -e
Let's write a Bash script to use hello_world
the print function Hello World
. We will use it outside of the function set -e
.
set -e
Only used to write or set error display codes.
#!/bin/bash
set -e
function hello_world()
{
echo "Hello World!"
}
hello_world
Output:
Hello World!
Use in Bash function bodiesset -e
Now, we will set -e
place the inside a function in the above script.
#!/bin/bash
function hello_world()
{
set -e
echo "Hello World!"
}
hello_world
Output:
Hello World!
Using it inside or outside a function set-e
will not affect our output.
set -e
andtrap
set -e
The command instructs the terminal to throw an exception when an error is detected, causing the code to stop executing. trap
The keyword allows you to use a built-in function ERR
that accepts the error line number and passes it to the error function.
Let’s look at an example.
#!/bin/bash
set -e
function error()
{
echo "error at $1"
}
trap 'error $LINENO' ERR
errors
We create a function error
and use a shell variable $1
to store the line number where the error occurred.
Output:
demo.sh: line 9: errors: command not found
error at 9
demo.sh
is the name of the script file that contains the above script.
If one line of a script fails, but the last line succeeds, the entire script is considered successful. Therefore, it is easy to ignore errors.
Error tolerance is much better in scripts, and set -e
provides that for you.
For reprinting, please send an email to 1244347461@qq.com for approval. After obtaining the author's consent, kindly include the source as a link.
Related Articles
How to decompress x.tar.xz format files under Linux
Publish Date:2025/04/08 Views:186 Category:OPERATING SYSTEM
-
A lot of software found today is in the tar.xz format, which is a lossless data compression file format that uses the LZMA compression algorithm. Like gzip and bzip2, it supports multiple file compression, but the convention is not to compr
Summary of vim common commands
Publish Date:2025/04/08 Views:115 Category:OPERATING SYSTEM
-
In Linux, the best editor should be vim. However, the complex commands behind vim's powerful functions also make us daunted. Of course, these commands do not need to be memorized by rote. As long as you practice using vim more, you can reme
Detailed explanation of command return value $? in Linux
Publish Date:2025/04/08 Views:58 Category:OPERATING SYSTEM
-
? is a special variable. This variable represents the return value of the previous command. That is to say, when we run certain commands, these commands will return a code after running. Generally, if the command is successfully run, the re
Common judgment formulas for Linux script shell
Publish Date:2025/04/08 Views:159 Category:OPERATING SYSTEM
-
In shell script programming, predicates are often used. There are two ways to use predicates, one is to use test, and the other is to use []. Let's take a look at how to use these two methods through two simple examples. Example 1 # test –
Shell script programming practice - specify a directory to delete files
Publish Date:2025/04/08 Views:98 Category:OPERATING SYSTEM
-
Usually, in Linux system we need to frequently delete some temporary files or junk files. If we delete them one by one manually, it will be quite troublesome. I have also been learning shell script programming recently, so I tried to write
Use of Linux command at - set time to execute command only once
Publish Date:2025/04/08 Views:158 Category:OPERATING SYSTEM
-
This article mainly involves a knowledge point, which is the atd service. Similar to this service is the crond service. The functions of these two services can be similar to the two functional functions of javascript. Those who have learned
Use of Linux command crontab - loop execution of set commands
Publish Date:2025/04/08 Views:170 Category:OPERATING SYSTEM
-
Compared with at , which executes a command only once, crontab, which we are going to talk about in this article, executes the set commands in a loop. Similarly, the use of crontab requires the support of the crond service. The service is s
Linux practice - regularly delete files under the directory
Publish Date:2025/04/08 Views:198 Category:OPERATING SYSTEM
-
Since we want to delete the files under the directory regularly, we need to use the Linux crontab command. And the content format of each work routine is also introduced in the format of each crontab work. Similarly, we need to use shell sc
How to use the Linux file remote copy command scp
Publish Date:2025/04/08 Views:151 Category:OPERATING SYSTEM
-
Scp copies files between two hosts over the network, and the data is encrypted during transmission. Its underlying layer uses ssh for data transmission. And it has the same authentication mechanism and the same security level as ssh. When u